import _extends from "@babel/runtime/helpers/esm/extends";

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import { Phases, symbol } from './constants';
import { shouldProduceEvent, shouldThrow } from './aggregate-assertions';
var internalPromise = Symbol();

var getDelayedPromise = function getDelayedPromise(continuation) {
  var _promise;

  var promise = (_promise = {}, _promise[internalPromise] = {
    thenFunctions: [],
    catchFunctions: [],
    state: null,
    result: null
  }, _promise.then = function then(nextSuccess, nextFailure) {
    if (promise[internalPromise].state == null) {
      promise[internalPromise].thenFunctions.push(nextSuccess);
    } else if (promise[internalPromise].state === true) {
      nextSuccess(promise[internalPromise].result);
    }

    if (nextFailure != null) {
      if (promise[internalPromise].state == null) {
        promise[internalPromise].catchFunctions.push(nextFailure);
      } else if (promise[internalPromise].state === false) {
        nextFailure(promise[internalPromise].result);
      }
    }
  }, _promise["catch"] = function _catch(nextFailure) {
    if (promise[internalPromise].state == null) {
      promise[internalPromise].catchFunctions.push(nextFailure);
    } else if (promise[internalPromise].state === false) {
      nextFailure(promise[internalPromise].result);
    }
  }, _promise);

  var promiseResolve = function promiseResolve(result) {
    if (promise[internalPromise].state == null) {
      promise[internalPromise].state = true;
      promise[internalPromise].result = result;

      for (var _iterator = _createForOfIteratorHelperLoose(promise[internalPromise].thenFunctions), _step; !(_step = _iterator()).done;) {
        var next = _step.value;
        next(result);
      }

      promise[internalPromise].thenFunctions.length = 0;
    }
  };

  var promiseReject = function promiseReject(result) {
    if (promise[internalPromise].state == null) {
      promise[internalPromise].state = false;
      promise[internalPromise].result = result;

      for (var _iterator2 = _createForOfIteratorHelperLoose(promise[internalPromise].catchFunctions), _step2; !(_step2 = _iterator2()).done;) {
        var next = _step2.value;
        next(result);
      }

      promise[internalPromise].catchFunctions.length = 0;
    }
  };

  var promiseThen = promise.then.bind(promise);
  var promiseCatch = promise["catch"].bind(promise);
  promise.then = continuation.bind(null, promiseThen);
  promise["catch"] = continuation.bind(null, promiseCatch);
  return {
    promiseResolve: promiseResolve,
    promiseReject: promiseReject,
    promise: promise
  };
};

var getInitPromise = function getInitPromise(internalPool) {
  return new Promise(function (resolve) {
    internalPool.initResolve = function (continuation) {
      resolve();

      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      return continuation.apply(void 0, args);
    };
  });
};

var givenEvents = function givenEvents(dependencies, events) {
  var readModel = dependencies.readModel,
      as = dependencies.as,
      execute = dependencies.execute,
      saga = dependencies.saga,
      properties = dependencies.properties,
      setSecretsManager = dependencies.setSecretsManager,
      getDefaultSecretsManager = dependencies.getDefaultSecretsManager,
      aggregate = dependencies.aggregate,
      command = dependencies.command;
  var internalPool = Object.create(null);
  var initPromise = getInitPromise(internalPool);

  var _getDelayedPromise = getDelayedPromise(internalPool.initResolve),
      promiseResolve = _getDelayedPromise.promiseResolve,
      promiseReject = _getDelayedPromise.promiseReject,
      promise = _getDelayedPromise.promise;

  var pool = _extends({}, dependencies, {
    promise: promise
  });

  promise[symbol] = internalPool;
  promise[symbol].resolve = promiseResolve;
  promise[symbol].reject = promiseReject;
  promise[symbol].initPromise = initPromise;
  promise[symbol].events = events;
  promise[symbol].phase = Phases.GIVEN_EVENTS;
  promise[symbol].secretsManager = getDefaultSecretsManager();
  promise[symbol].properties = {
    RESOLVE_SIDE_EFFECTS_START_TIMESTAMP: 0
  };
  promise.readModel = readModel.bind(null, pool);
  promise.as = as.bind(null, pool);
  promise.saga = saga.bind(null, pool);
  promise.properties = properties.bind(null, pool);
  promise.setSecretsManager = setSecretsManager.bind(null, pool);
  promise.aggregate = aggregate.bind(null, promise);
  promise.command = command.bind(null, promise);
  promise.shouldProduceEvent = shouldProduceEvent.bind(null, promise);
  promise.shouldThrow = shouldThrow.bind(null, promise);
  initPromise.then(execute.bind(null, pool));
  return promise;
};

export default givenEvents;
//# sourceMappingURL=given-events.js.map