import { createQuery, createCommand } from '@resolve-js/runtime';
import as from './as';
import givenEvents from './given-events';
import { execute } from './execute';
import readModel from './read-model';
import transformEvents from './transform-events';
import { executeReadModel } from './execute-read-model';
import { executeSaga } from './execute-saga';
import { executeCommand } from './execute-command';
import saga from './saga';
import properties from './properties';
import getDefaultSecretsManager from './secrets-manager';
import setSecretsManager from './set-secrets-manager';
import { aggregate, BDDAggregate } from './aggregate';
import { command } from './command';
export { BDDAggregate };
export default givenEvents.bind(null, {
  createQuery: createQuery,
  createCommand: createCommand,
  as: as,
  execute: execute,
  executeSaga: executeSaga,
  executeReadModel: executeReadModel,
  executeCommand: executeCommand,
  readModel: readModel,
  transformEvents: transformEvents,
  saga: saga,
  properties: properties,
  getDefaultSecretsManager: getDefaultSecretsManager,
  setSecretsManager: setSecretsManager,
  aggregate: aggregate,
  command: command
});
export var RESOLVE_SIDE_EFFECTS_START_TIMESTAMP = 'RESOLVE_SIDE_EFFECTS_START_TIMESTAMP';
export var schedulerName = '_SCHEDULER_';
export var getSchedulersNamesBySagas = function getSchedulersNamesBySagas(sagas) {
  if (!Array.isArray(sagas)) {
    throw new Error("Sagas " + sagas + " is not array");
  }

  var uniqueSagaConnectorsNames = Array.from(new Set(sagas.map(function (saga) {
    return saga.connectorName;
  })));
  var schedulersNames = [];

  for (var _i = 0, _uniqueSagaConnectors = uniqueSagaConnectorsNames; _i < _uniqueSagaConnectors.length; _i++) {
    var connectorName = _uniqueSagaConnectors[_i];
    // eslint-disable-next-line no-new-wrappers
    var currentSchedulerName = new String("" + schedulerName + connectorName);
    currentSchedulerName.connectorName = connectorName;
    schedulersNames.push(currentSchedulerName);
  }

  return schedulersNames;
};
//# sourceMappingURL=index.js.map