import _extends from "@babel/runtime/helpers/esm/extends";

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var transformEvents = function transformEvents(events, target, context) {
  if (target === void 0) {
    target = 'read-model';
  }

  var timestamp = 1;
  var aggregateVersionsMap = new Map();
  var threadCountersMap = new Map();
  var result = [];

  for (var _iterator = _createForOfIteratorHelperLoose(events), _step; !(_step = _iterator()).done;) {
    var rawEvent = _step.value;
    var aggregateId = target === 'aggregate' ? context == null ? void 0 : context.aggregateId : rawEvent.aggregateId;
    var aggregateVersion = aggregateVersionsMap.has(aggregateId) ? aggregateVersionsMap.get(aggregateId) + 1 : 1;
    var threadId = Buffer.from(JSON.stringify(rawEvent)).reduce(function (acc, val) {
      return (acc + val) % 256;
    }, 0);
    var threadCounter = threadCountersMap.has(threadId) ? threadCountersMap.get(threadId) + 1 : 1;

    var event = _extends({}, rawEvent, {
      aggregateId: aggregateId,
      aggregateVersion: aggregateVersion,
      timestamp: timestamp++,
      threadId: threadId,
      threadCounter: threadCounter
    });

    result.push(event);
    aggregateVersionsMap.set(aggregateId, aggregateVersion);
    threadCountersMap.set(threadId, threadCounter + 1);
  }

  return result;
};

export default transformEvents;
//# sourceMappingURL=transform-events.js.map