"use strict";

exports.__esModule = true;
exports.aggregate = void 0;

var _constants = require("./constants");

var aggregate = function aggregate(context, _aggregate, aggregateId) {
  if (context[_constants.symbol].phase !== _constants.Phases.GIVEN_EVENTS) {
    throw new TypeError();
  }

  context[_constants.symbol].phase = _constants.Phases.AGGREGATE;
  context[_constants.symbol].aggregate = {
    name: _aggregate.name,
    commands: _aggregate.commands || {},
    projection: _aggregate.projection || {},
    encryption: _aggregate.encryption
  };
  context[_constants.symbol].aggregateId = aggregateId || 'test-aggregate-id';

  context[_constants.symbol].assertion = function (resolve, reject, result, error) {
    if (error != null) {
      reject(error);
    } else {
      resolve(result);
    }
  };

  context[_constants.symbol].isDefaultAssertion = true;
  return context;
};

exports.aggregate = aggregate;
//# sourceMappingURL=aggregate.js.map