"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.executeReadModel = void 0;

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _constants = require("./constants");

var _core = require("@resolve-js/core");

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var executeReadModel = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(_ref) {
    var promise, createQuery, transformEvents, errors, queryExecutor, result, provideLedger, secretsManager, liveErrors, wrapProjectionLiveErrors, domain, eventStoreLocalState, eventstoreAdapter, status, liveErrorIndex, error, _yield$queryExecutor$, summaryError;

    return _regenerator["default"].wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            promise = _ref.promise, createQuery = _ref.createQuery, transformEvents = _ref.transformEvents;

            if (!(promise[_constants.symbol].phase < _constants.Phases.RESOLVER)) {
              _context8.next = 3;
              break;
            }

            throw new TypeError(promise[_constants.symbol].phase);

          case 3:
            errors = [];
            queryExecutor = null;
            result = null;
            _context8.prev = 6;

            provideLedger = /*#__PURE__*/function () {
              var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(ledger) {
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        return _context.abrupt("return", void 0);

                      case 1:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function provideLedger(_x2) {
                return _ref3.apply(this, arguments);
              };
            }();

            secretsManager = promise[_constants.symbol].secretsManager;
            liveErrors = [];

            wrapProjectionLiveErrors = function wrapProjectionLiveErrors(projection) {
              return Object.keys(projection).reduce(function (acc, key) {
                var _extends2;

                return (0, _extends3["default"])({}, acc, (_extends2 = {}, _extends2[key] = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
                  var _args2 = arguments;
                  return _regenerator["default"].wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          _context2.prev = 0;
                          _context2.next = 3;
                          return projection[key].apply(projection, _args2);

                        case 3:
                          return _context2.abrupt("return", _context2.sent);

                        case 6:
                          _context2.prev = 6;
                          _context2.t0 = _context2["catch"](0);
                          liveErrors.push(_context2.t0);
                          throw _context2.t0;

                        case 10:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2, null, [[0, 6]]);
                })), _extends2));
              }, {});
            };

            domain = (0, _core.initDomain)({
              viewModels: [],
              readModels: [{
                name: promise[_constants.symbol].name,
                projection: wrapProjectionLiveErrors(promise[_constants.symbol].projection),
                resolvers: promise[_constants.symbol].resolvers,
                connectorName: 'ADAPTER_NAME',
                encryption: promise[_constants.symbol].encryption
              }],
              aggregates: [],
              sagas: []
            });
            eventStoreLocalState = new Map();
            eventstoreAdapter = {
              getSecretsManager: function getSecretsManager() {
                return promise[_constants.symbol].secretsManager;
              },
              loadEvents: function () {
                var _loadEvents = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
                  return _regenerator["default"].wrap(function _callee3$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          _context3.t0 = transformEvents(promise[_constants.symbol].events);
                          return _context3.abrupt("return", {
                            events: _context3.t0,

                            get cursor() {
                              throw new Error('Cursor should not be accessed from @resolve-js/testing-tools');
                            }

                          });

                        case 2:
                        case "end":
                          return _context3.stop();
                      }
                    }
                  }, _callee3);
                }));

                function loadEvents() {
                  return _loadEvents.apply(this, arguments);
                }

                return loadEvents;
              }(),
              getNextCursor: function getNextCursor() {
                return 'SHIFT_CURSOR';
              },
              ensureEventSubscriber: function () {
                var _ensureEventSubscriber = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(_ref5) {
                  var applicationName, eventSubscriber, destination, status;
                  return _regenerator["default"].wrap(function _callee4$(_context4) {
                    while (1) {
                      switch (_context4.prev = _context4.next) {
                        case 0:
                          applicationName = _ref5.applicationName, eventSubscriber = _ref5.eventSubscriber, destination = _ref5.destination, status = _ref5.status;
                          eventStoreLocalState.set("" + applicationName + eventSubscriber, (0, _extends3["default"])({}, eventStoreLocalState.has("" + applicationName + eventSubscriber) ? eventStoreLocalState.get("" + applicationName + eventSubscriber) : {}, destination != null ? {
                            destination: destination
                          } : {}, status != null ? {
                            status: status
                          } : {}));

                        case 2:
                        case "end":
                          return _context4.stop();
                      }
                    }
                  }, _callee4);
                }));

                function ensureEventSubscriber(_x3) {
                  return _ensureEventSubscriber.apply(this, arguments);
                }

                return ensureEventSubscriber;
              }(),
              removeEventSubscriber: function () {
                var _removeEventSubscriber = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(_ref6) {
                  var applicationName, eventSubscriber;
                  return _regenerator["default"].wrap(function _callee5$(_context5) {
                    while (1) {
                      switch (_context5.prev = _context5.next) {
                        case 0:
                          applicationName = _ref6.applicationName, eventSubscriber = _ref6.eventSubscriber;
                          eventStoreLocalState["delete"]("" + applicationName + eventSubscriber);

                        case 2:
                        case "end":
                          return _context5.stop();
                      }
                    }
                  }, _callee5);
                }));

                function removeEventSubscriber(_x4) {
                  return _removeEventSubscriber.apply(this, arguments);
                }

                return removeEventSubscriber;
              }(),
              getEventSubscribers: function () {
                var _getEventSubscribers = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(_temp) {
                  var _ref7, applicationName, eventSubscriber, result, _iterator, _step, _step$value, key, _step$value$, destination, status;

                  return _regenerator["default"].wrap(function _callee6$(_context6) {
                    while (1) {
                      switch (_context6.prev = _context6.next) {
                        case 0:
                          _ref7 = _temp === void 0 ? {} : _temp, applicationName = _ref7.applicationName, eventSubscriber = _ref7.eventSubscriber;

                          if (!(applicationName == null && eventSubscriber == null)) {
                            _context6.next = 3;
                            break;
                          }

                          return _context6.abrupt("return", [].concat(eventStoreLocalState.values()));

                        case 3:
                          result = [];

                          for (_iterator = _createForOfIteratorHelperLoose(eventStoreLocalState.entries()); !(_step = _iterator()).done;) {
                            _step$value = _step.value, key = _step$value[0], _step$value$ = _step$value[1], destination = _step$value$.destination, status = _step$value$.status;

                            if ("" + applicationName + eventSubscriber === key) {
                              result.push({
                                applicationName: applicationName,
                                eventSubscriber: eventSubscriber,
                                destination: destination,
                                status: status
                              });
                            }
                          }

                          return _context6.abrupt("return", result);

                        case 6:
                        case "end":
                          return _context6.stop();
                      }
                    }
                  }, _callee6);
                }));

                function getEventSubscribers(_x5) {
                  return _getEventSubscribers.apply(this, arguments);
                }

                return getEventSubscribers;
              }()
            };
            queryExecutor = createQuery({
              applicationName: 'APP_NAME',
              readModelConnectors: {
                ADAPTER_NAME: promise[_constants.symbol].adapter
              },
              getVacantTimeInMillis: function getVacantTimeInMillis() {
                return 0x7fffffff;
              },
              invokeEventSubscriberAsync: function () {
                var _invokeEventSubscriberAsync = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
                  return _regenerator["default"].wrap(function _callee7$(_context7) {
                    while (1) {
                      switch (_context7.prev = _context7.next) {
                        case 0:
                          return _context7.abrupt("return", void 0);

                        case 1:
                        case "end":
                          return _context7.stop();
                      }
                    }
                  }, _callee7);
                }));

                function invokeEventSubscriberAsync() {
                  return _invokeEventSubscriberAsync.apply(this, arguments);
                }

                return invokeEventSubscriberAsync;
              }(),
              eventstoreAdapter: eventstoreAdapter,
              readModelsInterop: domain.readModelDomain.acquireReadModelsInterop({
                secretsManager: secretsManager,
                monitoring: {}
              }),
              viewModelsInterop: {},
              performanceTracer: null,
              provideLedger: provideLedger
            });
            _context8.prev = 15;
            _context8.next = 18;
            return eventstoreAdapter.ensureEventSubscriber({
              applicationName: 'APP_NAME',
              eventSubscriber: promise[_constants.symbol].name,
              status: null,
              destination: 'LOCAL'
            });

          case 18:
            _context8.next = 20;
            return queryExecutor.subscribe({
              modelName: promise[_constants.symbol].name,
              subscriptionOptions: {
                eventTypes: null,
                aggregateIds: null
              }
            });

          case 20:
            _context8.next = 22;
            return queryExecutor.resume({
              modelName: promise[_constants.symbol].name
            });

          case 22:
            _context8.next = 24;
            return queryExecutor.build({
              modelName: promise[_constants.symbol].name
            });

          case 24:
            _context8.next = 26;
            return queryExecutor.build({
              modelName: promise[_constants.symbol].name
            });

          case 26:
            _context8.next = 28;
            return queryExecutor.status({
              modelName: promise[_constants.symbol].name
            });

          case 28:
            status = _context8.sent;

            if (!(status.status === 'error')) {
              _context8.next = 40;
              break;
            }

            if (Array.isArray(status.errors)) {
              _context8.next = 32;
              break;
            }

            throw new Error('Unknown error');

          case 32:
            liveErrorIndex = status.errors.length === 1 ? liveErrors.findIndex(function (err) {
              return err.message === status.errors[0].message;
            }) : -1;

            if (!(liveErrorIndex < 0)) {
              _context8.next = 39;
              break;
            }

            error = new Error(status.errors.map(function (err) {
              return err.message;
            }).join('\n'));
            error.stack = status.errors.map(function (err) {
              return err.stack;
            }).join('\n');
            throw error;

          case 39:
            throw liveErrors[liveErrorIndex];

          case 40:
            _context8.next = 45;
            break;

          case 42:
            _context8.prev = 42;
            _context8.t0 = _context8["catch"](15);
            errors.push(_context8.t0);

          case 45:
            _context8.prev = 45;
            _context8.next = 48;
            return queryExecutor.read({
              modelName: promise[_constants.symbol].name,
              resolverName: promise[_constants.symbol].resolverName,
              resolverArgs: promise[_constants.symbol].resolverArgs,
              jwt: promise[_constants.symbol].jwt
            });

          case 48:
            _yield$queryExecutor$ = _context8.sent;
            result = _yield$queryExecutor$.data;
            void _yield$queryExecutor$;
            _context8.next = 56;
            break;

          case 53:
            _context8.prev = 53;
            _context8.t1 = _context8["catch"](45);
            errors.push(_context8.t1);

          case 56:
            _context8.prev = 56;
            _context8.next = 59;
            return queryExecutor.unsubscribe({
              modelName: promise[_constants.symbol].name
            });

          case 59:
            _context8.next = 64;
            break;

          case 61:
            _context8.prev = 61;
            _context8.t2 = _context8["catch"](56);
            errors.push(_context8.t2);

          case 64:
            _context8.prev = 64;
            _context8.next = 67;
            return eventstoreAdapter.removeEventSubscriber({
              applicationName: 'APP_NAME',
              eventSubscriber: promise[_constants.symbol].name
            });

          case 67:
            _context8.next = 72;
            break;

          case 69:
            _context8.prev = 69;
            _context8.t3 = _context8["catch"](64);
            errors.push(_context8.t3);

          case 72:
            _context8.next = 77;
            break;

          case 74:
            _context8.prev = 74;
            _context8.t4 = _context8["catch"](6);
            errors.push(_context8.t4);

          case 77:
            _context8.prev = 77;

            if (!(queryExecutor != null)) {
              _context8.next = 87;
              break;
            }

            _context8.prev = 79;
            _context8.next = 82;
            return queryExecutor.dispose();

          case 82:
            _context8.next = 87;
            break;

          case 84:
            _context8.prev = 84;
            _context8.t5 = _context8["catch"](79);
            errors.push(_context8.t5);

          case 87:
            return _context8.finish(77);

          case 88:
            if (errors.length === 0) {
              promise[_constants.symbol].resolve(result);
            } else {
              summaryError = errors[0];

              if (errors.length > 1) {
                summaryError = new Error(errors.map(function (err) {
                  return err.message;
                }).join('\n'));
                summaryError.stack = errors.map(function (err) {
                  return err.stack;
                }).join('\n');
              } // eslint-disable-next-line no-console


              console.error(summaryError);

              promise[_constants.symbol].reject(errors[0]);
            }

          case 89:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8, null, [[6, 74, 77, 88], [15, 42], [45, 53], [56, 61], [64, 69], [79, 84]]);
  }));

  return function executeReadModel(_x) {
    return _ref2.apply(this, arguments);
  };
}();

exports.executeReadModel = executeReadModel;
//# sourceMappingURL=execute-read-model.js.map