"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.getSchedulersNamesBySagas = exports.schedulerName = exports.RESOLVE_SIDE_EFFECTS_START_TIMESTAMP = exports["default"] = void 0;

var _runtime = require("@resolve-js/runtime");

var _as = _interopRequireDefault(require("./as"));

var _givenEvents = _interopRequireDefault(require("./given-events"));

var _execute = require("./execute");

var _readModel = _interopRequireDefault(require("./read-model"));

var _transformEvents = _interopRequireDefault(require("./transform-events"));

var _executeReadModel = require("./execute-read-model");

var _executeSaga = require("./execute-saga");

var _executeCommand = require("./execute-command");

var _saga = _interopRequireDefault(require("./saga"));

var _properties = _interopRequireDefault(require("./properties"));

var _secretsManager = _interopRequireDefault(require("./secrets-manager"));

var _setSecretsManager = _interopRequireDefault(require("./set-secrets-manager"));

var _aggregate = require("./aggregate");

exports.BDDAggregate = _aggregate.BDDAggregate;

var _command = require("./command");

var _default = _givenEvents["default"].bind(null, {
  createQuery: _runtime.createQuery,
  createCommand: _runtime.createCommand,
  as: _as["default"],
  execute: _execute.execute,
  executeSaga: _executeSaga.executeSaga,
  executeReadModel: _executeReadModel.executeReadModel,
  executeCommand: _executeCommand.executeCommand,
  readModel: _readModel["default"],
  transformEvents: _transformEvents["default"],
  saga: _saga["default"],
  properties: _properties["default"],
  getDefaultSecretsManager: _secretsManager["default"],
  setSecretsManager: _setSecretsManager["default"],
  aggregate: _aggregate.aggregate,
  command: _command.command
});

exports["default"] = _default;
var RESOLVE_SIDE_EFFECTS_START_TIMESTAMP = 'RESOLVE_SIDE_EFFECTS_START_TIMESTAMP';
exports.RESOLVE_SIDE_EFFECTS_START_TIMESTAMP = RESOLVE_SIDE_EFFECTS_START_TIMESTAMP;
var schedulerName = '_SCHEDULER_';
exports.schedulerName = schedulerName;

var getSchedulersNamesBySagas = function getSchedulersNamesBySagas(sagas) {
  if (!Array.isArray(sagas)) {
    throw new Error("Sagas " + sagas + " is not array");
  }

  var uniqueSagaConnectorsNames = Array.from(new Set(sagas.map(function (saga) {
    return saga.connectorName;
  })));
  var schedulersNames = [];

  for (var _i = 0, _uniqueSagaConnectors = uniqueSagaConnectorsNames; _i < _uniqueSagaConnectors.length; _i++) {
    var connectorName = _uniqueSagaConnectors[_i];
    // eslint-disable-next-line no-new-wrappers
    var currentSchedulerName = new String("" + schedulerName + connectorName);
    currentSchedulerName.connectorName = connectorName;
    schedulersNames.push(currentSchedulerName);
  }

  return schedulersNames;
};

exports.getSchedulersNamesBySagas = getSchedulersNamesBySagas;
//# sourceMappingURL=index.js.map